package ru.landgrafhomyak.db.serdha0.api.misc

import ru.landgrafhomyak.db.serdha0.api.runtime.InputRow
import ru.landgrafhomyak.db.serdha0.api.runtime.OutputRow

public interface Reducer<rUE : Any> {
	public val userExtension: rUE

	public interface IOColumn<RT, DT : DatabaseType<RT>, rUE : Any> : Column<RT, DT, rUE>, QueryParam<RT, DT, rUE>


	public fun interface ReduceLinker<rUE : Any, qUE : Any, oUE : Any> {
		public fun link(linker: Scope<rUE, qUE>): oUE

		public interface Scope<rUE : Any, qUE : Any> {
			public fun <RT, DT : DatabaseType<RT>> link(io: IOColumn<RT, DT, rUE>, src: IntermediateColumn<RT, DT, rUE>): IntermediateColumn<RT, DT, qUE>
		}
	}

	public fun interface FoldLinker<rUE : Any, qUE : Any, oUE : Any> {
		public fun link(linker: Scope<rUE, qUE>): oUE

		public interface Scope<rUE : Any, qUE : Any> {
			public fun <RT, DT : DatabaseType<RT>> link(io: IOColumn<RT, DT, rUE>, src: IntermediateColumn<RT, DT, rUE>, initial: RT): IntermediateColumn<RT, DT, qUE>
			public fun <RT, DT : DatabaseType<RT>> link(io: IOColumn<RT, DT, rUE>, src: IntermediateColumn<RT, DT, rUE>, initial: QueryParam<RT, DT, qUE>): IntermediateColumn<RT, DT, qUE>
		}
	}

	public interface Constructor<rUE : Any> {
		public fun createReducer(creator: Scope<rUE>): rUE

		public interface Scope<rUE : Any> {
			public fun <RT, DT : DatabaseType<RT>> io(name: String, type: DT): IOColumn<RT, DT, rUE>
			public var action: Action<rUE>
		}
	}

	public interface Action<rUE : Any> {
		public fun calculate(ue: rUE, acc: OutputRow<rUE>, row: OutputRow<rUE>, newAcc: InputRow<rUE>)
	}
}