package ru.landgrafhomyak.db.serdha0.api.runtime

import ru.landgrafhomyak.db.serdha0.api.LowLevelApi
import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.db.serdha0.api.misc.QueryParam

public interface InputRow<QueryUserExtension : Any/* todo*/> {
	public operator fun <RuntimeType> set(c: QueryParam<RuntimeType, *, QueryUserExtension>, value: RuntimeType)

	public operator fun set(c: QueryParam<Byte, *, QueryUserExtension>, value: Byte): Unit = this.set<Byte>(c, value)
	public operator fun set(c: QueryParam<UByte, *, QueryUserExtension>, value: UByte): Unit = this.set<UByte>(c, value)
	public operator fun set(c: QueryParam<Short, *, QueryUserExtension>, value: Short): Unit = this.set<Short>(c, value)
	public operator fun set(c: QueryParam<UShort, *, QueryUserExtension>, value: UShort): Unit = this.set<UShort>(c, value)
	public operator fun set(c: QueryParam<Int, *, QueryUserExtension>, value: Int): Unit = this.set<Int>(c, value)
	public operator fun set(c: QueryParam<UInt, *, QueryUserExtension>, value: UInt): Unit = this.set<UInt>(c, value)
	public operator fun set(c: QueryParam<Long, *, QueryUserExtension>, value: Long): Unit = this.set<Long>(c, value)
	public operator fun set(c: QueryParam<ULong, *, QueryUserExtension>, value: ULong): Unit = this.set<ULong>(c, value)
	public operator fun set(c: QueryParam<Char, *, QueryUserExtension>, value: Char): Unit = this.set<Char>(c, value)
	public operator fun set(c: QueryParam<Boolean, *, QueryUserExtension>, value: Boolean): Unit = this.set<Boolean>(c, value)

	public interface WithRedirect<QueryUserExtension : Any, ParentQueryUserExtension : Any> : InputRow<QueryUserExtension> {
		public fun <RT, DT : DatabaseType<RT>> redirect(c: QueryParam<RT, DT, QueryUserExtension>, value: QueryParam<RT, DT, ParentQueryUserExtension>)
	}

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Scope<QueryUserExtension : Any, out Next> : InputRow<QueryUserExtension> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _finish(): Next

		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _abort()
	}


	@Suppress("ClassName")
	@LowLevelApi
	public interface _Iterator<QueryUserExtension : Any, out Next> : _Scope<QueryUserExtension, Next> {
		@Suppress("FunctionName")
		@LowLevelApi
		public fun _next(): Boolean
	}
}