package ru.landgrafhomyak.db.serdha0.api.runtime

import ru.landgrafhomyak.db.serdha0.api.LowLevelApi
import ru.landgrafhomyak.db.serdha0.api.misc.Column

public interface OutputRow<QueryUserExtension : Any> {
	public operator fun <RuntimeType> get(c: Column<RuntimeType, *, QueryUserExtension>): RuntimeType

	public operator fun get(c: Column<Byte, *, QueryUserExtension>): Byte = this.get<Byte>(c)
	public operator fun get(c: Column<UByte, *, QueryUserExtension>): UByte = this.get<UByte>(c)
	public operator fun get(c: Column<Short, *, QueryUserExtension>): Short = this.get<Short>(c)
	public operator fun get(c: Column<UShort, *, QueryUserExtension>): UShort = this.get<UShort>(c)
	public operator fun get(c: Column<Int, *, QueryUserExtension>): Int = this.get<Int>(c)
	public operator fun get(c: Column<UInt, *, QueryUserExtension>): UInt = this.get<UInt>(c)
	public operator fun get(c: Column<Long, *, QueryUserExtension>): Long = this.get<Long>(c)
	public operator fun get(c: Column<ULong, *, QueryUserExtension>): ULong = this.get<ULong>(c)
	public operator fun get(c: Column<Char, *, QueryUserExtension>): Char = this.get<Char>(c)
	public operator fun get(c: Column<Boolean, *, QueryUserExtension>): Boolean = this.get<Boolean>(c)

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Iterator<QueryUserExtension : Any, out Next> : OutputRow<QueryUserExtension> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _next(): Boolean

		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _abort()

		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _finish(): Next
	}
}