package ru.landgrafhomyak.db.serdha0.api.table

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.serdha0.api.misc.Column
import ru.landgrafhomyak.db.serdha0.api.misc.IntermediateColumn
import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.db.serdha0.api.misc.Mapper

public interface CheckConstraint<tUE : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("name")
	public val name: String

	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("table")
	public val table: Table<tUE, *>

	public interface Creator<cUE : Any, ttUE : Any> {
		public fun createCheckConstraint(scope: Scope<cUE, ttUE>)

		public interface Scope<cUE : Any, ttUE : Any> {
			public val tt: Table<ttUE, *>

			public var result: IntermediateColumn<Boolean, DatabaseType.BOOLEAN, cUE>
			public fun <RT, DT : DatabaseType<RT>> selectFromTargetTable(column: Column<RT, DT, ttUE>): IntermediateColumn<RT, DT, cUE>

			public fun <rtUE : Any, RT, DT : DatabaseType<RT>> followReference(
				ref: IntermediateColumn<*, DatabaseType.ROW_ID<rtUE>, cUE>,
				column: Column<RT, DT, rtUE>
			): IntermediateColumn<RT, DT, rtUE>

			public fun <eUE : Any> mapColumns(
				expression: Mapper<eUE>,
				input: ru.landgrafhomyak.db.serdha0.api.misc.Expression.Map.InputLinker<eUE, cUE>,
				output: ru.landgrafhomyak.db.serdha0.api.misc.Expression.Map.OutputLinker<eUE, cUE>
			)
		}
	}
}